﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.Model;
using FarPoint.Win.Spread;

namespace Spread_Win_Group
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            txtGroupBarText.KeyUp += new KeyEventHandler(txtGroupBarText_KeyUp);
            txtGroupBarText.Leave += new EventHandler(txtGroupBarText_Leave);
        }
        void txtGroupBarText_Leave(object sender, EventArgs e)
        {
            if (txtGroupBarText.Text != null)
            {
                FpSpread1.ActiveSheet.GroupBarInfo.Text = txtGroupBarText.Text;
            }
        }
        void txtGroupBarText_KeyUp(object sender, KeyEventArgs e)
        {
            if ((e.KeyCode == Keys.Enter) & (txtGroupBarText.Text != null))
            {
                FpSpread1.ActiveSheet.GroupBarInfo.Text = txtGroupBarText.Text;
            }
        }
        private void Grouping_Load(object sender, EventArgs e)
        {
            // TODO: 这行代码将数据加载到表“销售数据清单DataSet.销售明细表”中。您可以根据需要移动或删除它。
            this.销售明细表TableAdapter.Fill(this.销售数据清单DataSet.销售明细表);
            FpSpread1.AllowColumnMove = true;
            FpSpread1.ScrollBarTrackPolicy = FarPoint.Win.Spread.ScrollBarTrackPolicy.Both;
            FpSpread1.Sheets[0].AllowGroup = true;
            FpSpread1.Sheets[0].GroupBarVisible = true;
            for (int intC = 0; intC < FpSpread1.Sheets[0].ColumnCount; intC++)
                FpSpread1.Sheets[0].Columns[intC].Width = FpSpread1.Sheets[0].GetPreferredColumnWidth(intC);
            FpSpread1.Sheets[0].DefaultStyle.BackColor = Color.AliceBlue;
        }
        private void btnGroup_Click(object sender, EventArgs e)
        {
            if ((FpSpread1.Sheets[0].Models.Data != null) && (FpSpread1.Sheets[0].Models.Data is GroupDataModel))
            {
                GroupDataModel gm = null;
                gm = FpSpread1.Sheets[0].Models.Data as GroupDataModel;
                if (gm.SortInfo.Length < FpSpread1.Sheets[0].GroupMaximumLevel)
                {
                    int n = gm.SortInfo.Length;
                    FarPoint.Win.Spread.SortInfo[] tmp = new SortInfo[n + 1];
                    int j = 0;
                    int i = 0;
                    while (i < n)
                    {
                        if (gm.SortInfo[i].Index != FpSpread1.Sheets[0].GetModelColumnFromViewColumn(FpSpread1.Sheets[0].ActiveColumnIndex))
                            tmp[j] = gm.SortInfo[i];
                        else
                            return;
                        tmp[j] = new FarPoint.Win.Spread.SortInfo(FpSpread1.Sheets[0].GetModelColumnFromViewColumn(FpSpread1.Sheets[0].ActiveColumnIndex), true);
                        tmp[j + 1] = gm.SortInfo[i];
                        i = i + 1;
                        j = j + 1;
                    }
                    tmp[j] = new FarPoint.Win.Spread.SortInfo(FpSpread1.Sheets[0].GetModelColumnFromViewColumn(FpSpread1.Sheets[0].ActiveColumnIndex), true);
                    n = n + 1;
                    if (n > 1)
                    {
                        GroupingEventArgs fe = new GroupingEventArgs(tmp);
                        if (!fe.Cancel)
                        {
                            gm.Group(tmp, fe.GroupComparer);
                        }
                    }
                }
            }
            else
            {
                FarPoint.Win.Spread.Model.GroupDataModel gm = new FarPoint.Win.Spread.Model.GroupDataModel(FpSpread1.Sheets[0].Models.Data);
                FarPoint.Win.Spread.SortInfo[] si = new FarPoint.Win.Spread.SortInfo[] { new FarPoint.Win.Spread.SortInfo(FpSpread1.Sheets[0].ActiveColumnIndex, true) };
                gm.Group(si);
                try
                {
                    FpSpread1.Sheets[0].Models.Data = gm;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }
        private void btnRemove_Click(object sender, EventArgs e)
        {
            try
            {
                if ((FpSpread1.Sheets[0].Models.Data != null) && (FpSpread1.Sheets[0].Models.Data is GroupDataModel))
                {
                    GroupDataModel gm = null;
                    gm = FpSpread1.Sheets[0].Models.Data as GroupDataModel;
                    int n = gm.SortInfo.Length;
                    FarPoint.Win.Spread.SortInfo[] tmp = new FarPoint.Win.Spread.SortInfo[n - 1];
                    int i = 0;
                    while (i < n - 1)
                    {
                        tmp[i] = gm.SortInfo[i];
                        i = i + 1;
                    }
                    n = n - 1;
                    if (n >= 1)
                    {
                        GroupingEventArgs fe = new GroupingEventArgs(tmp);
                        if (!fe.Cancel)
                            gm.Group(tmp, fe.GroupComparer);
                        return;
                    }
                    else
                        FpSpread1.Sheets[0].Models.Data = ((FarPoint.Win.Spread.Model.GroupDataModel)FpSpread1.Sheets[0].Models.Data).TargetModel;
                }
            }
            catch
            {
            }
        }
        private void radioButtonNotSet_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonNotSet.Checked == true)
            {
                radioButtonCollapseAll.Checked = false;
                radioButtonExpandAll.Checked = false;
                radioButtonExpandParent.Checked = false;
                FpSpread1.Sheets[0].GroupingPolicy = FarPoint.Win.Spread.Model.GroupingPolicy.NotSet;
            }
        }
        private void radioButtonExpandAll_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonExpandAll.Checked == true)
            {
                radioButtonCollapseAll.Checked = false;
                radioButtonNotSet.Checked = false;
                radioButtonExpandParent.Checked = false;
                FpSpread1.Sheets[0].GroupingPolicy = FarPoint.Win.Spread.Model.GroupingPolicy.ExpandAll;
            }
        }
        private void radioButtonCollapseAll_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonCollapseAll.Checked == true)
            {
                radioButtonExpandAll.Checked = false;
                radioButtonNotSet.Checked = false;
                radioButtonExpandParent.Checked = false;
                FpSpread1.Sheets[0].GroupingPolicy = FarPoint.Win.Spread.Model.GroupingPolicy.CollapseAll;
            }
        }
        private void radioButtonExpandParent_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonExpandParent.Checked == true)
            {
                radioButtonExpandAll.Checked = false;
                radioButtonNotSet.Checked = false;
                radioButtonCollapseAll.Checked = false;
                FpSpread1.Sheets[0].GroupingPolicy = FarPoint.Win.Spread.Model.GroupingPolicy.ExpandParents;
            }
        }
        private void btnBackColor_Click(object sender, EventArgs e)
        {
            colorDialog1.Color = FpSpread1.ActiveSheet.GroupBarInfo.BackColor;
            colorDialog1.ShowDialog();
            if (!colorDialog1.Color.Equals(FpSpread1.ActiveSheet.GroupBarInfo.BackColor))
            {
                FpSpread1.ActiveSheet.GroupBarInfo.BackColor = colorDialog1.Color;
                FpSpread1.Refresh();
            }
        }
        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            if (numericUpDown1.Value > 0)
            {
                FpSpread1.ActiveSheet.GroupBarInfo.Height = Convert.ToInt32(numericUpDown1.Value);
            }
        }
        private void btnForeColor_Click(object sender, EventArgs e)
        {
            colorDialog1.Color = FpSpread1.ActiveSheet.GroupBarInfo.ForeColor;
            colorDialog1.ShowDialog();
            if (!colorDialog1.Color.Equals(FpSpread1.ActiveSheet.GroupBarInfo.ForeColor))
            {
                FpSpread1.ActiveSheet.GroupBarInfo.ForeColor = colorDialog1.Color;
                FpSpread1.Refresh();
            }
        }
    }
}